#include "../main.h"
#include "../config.h"
#include "../init.h"
#include "../theme.h"
#include "../language.h"
#include "../message_dialog.h"
#include "../ime_dialog.h"
#include "../utils.h"
#include "../vitaident/utils.h"
#include "netprofilecheck.h"

static int n_NetProfileCheck_entries = 0;
static NetProfileCheckMenu NetProfileCheck_menu;

static char patch[MAX_PATH_LENGTH];

static int MenuSelection = 1; // Pretty obvious
static int selector_x = 17; //The x position of the first selection
static int selector_y = 26; //The y position of the first selection
static int numMenuItems = 10; //Amount of items in the menu

void profile01()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 1");
	
	if (regMgrGetInt("/CONFIG/NET/01/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/01/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/01/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/01/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/01/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/01/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile02()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 2");
	
	if (regMgrGetInt("/CONFIG/NET/02/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/02/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/02/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/02/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/02/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/02/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile03()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 3");
	
	if (regMgrGetInt("/CONFIG/NET/03/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/03/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/03/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/03/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/03/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/03/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile04()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 4");
	
	if (regMgrGetInt("/CONFIG/NET/04/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/04/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/04/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/04/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/04/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/04/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile05()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 5");
	
	if (regMgrGetInt("/CONFIG/NET/05/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/05/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/05/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/05/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/05/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/05/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile06()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 6");
	
	if (regMgrGetInt("/CONFIG/NET/06/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/06/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/06/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/06/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/06/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/06/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile07()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 7");
	
	if (regMgrGetInt("/CONFIG/NET/07/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/07/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/07/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/07/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/07/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/07/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile08()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 8");
	
	if (regMgrGetInt("/CONFIG/NET/08/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/08/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/08/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/08/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/08/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/08/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile09()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 9");
	
	if (regMgrGetInt("/CONFIG/NET/09/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/09/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/09/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/09/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/09/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/09/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void profile10()
{		
	float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
	
	pgf_draw_text( 585, 130+y2, NETPROFILECHECK_TITLE_COLOR, 1, "Net Profile 10");
	
	if (regMgrGetInt("/CONFIG/NET/10/WIFI/", "wifi_security") == 2)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/10/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wi-Fi Protected Access (WPA)");
		snprintf(patch, MAX_PATH_LENGTH, "WPA key: %s\n", regMgrGetStr("/CONFIG/NET/10/WIFI/", "wpa_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else if (regMgrGetInt("/CONFIG/NET/10/WIFI/", "wifi_security") == 1)
	{
		snprintf(patch, MAX_PATH_LENGTH, "SSID: %s\n", regMgrGetStr("/CONFIG/NET/10/WIFI/", "ssid"));
		pgf_draw_text( 364, 300+y2, NETPROFILECHECK_SSID_COLOR, 1, patch);
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_SECUR_COLOR, 1, "Wi-Fi security: Wired Equivalent Privacy (WEP)");
		snprintf(patch, MAX_PATH_LENGTH, "WEP key: %s\n", regMgrGetStr("/CONFIG/NET/10/WIFI/", "wep_key"));
		pgf_draw_text( 364, 400+y2, NETPROFILECHECK_KEY_COLOR, 1, patch);
	}
	else
		pgf_draw_text( 364, 350+y2, NETPROFILECHECK_NOEXIST_COLOR, 1, "This profile does not exist");
}

void npc_mainMenu()
{
		uint32_t eC = epileptik();
		float y2 = SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos;
				
		if (MenuSelection == 1)
			pgf_draw_text( 25, 92+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 1");
		else 
			pgf_draw_text( 25, 92+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 1");
		
		if (MenuSelection == 2)
			pgf_draw_text( 25, 132+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 2");
		else
			pgf_draw_text( 25, 132+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 2");
		
		if (MenuSelection == 3)
			pgf_draw_text( 25, 172+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 3");
		else
			pgf_draw_text( 25, 172+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 3");
		
		if (MenuSelection == 4)
			pgf_draw_text( 25, 212+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 4");
		else
			pgf_draw_text( 25, 212+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 4");
		
		if (MenuSelection == 5)
			pgf_draw_text( 25, 252+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 5");
		else
			pgf_draw_text( 25, 252+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 5");
		
		if (MenuSelection == 6)
			pgf_draw_text( 25, 292+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 6");
		else
			pgf_draw_text( 25, 292+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 6");
		
		if (MenuSelection == 7)
			pgf_draw_text( 25, 332+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 7");
		else
			pgf_draw_text( 25, 332+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 7");
		
		if (MenuSelection == 8)
			pgf_draw_text( 25, 372+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 8");
		else
			pgf_draw_text( 25, 372+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 8");
		
		if (MenuSelection == 9)
			pgf_draw_text( 25, 412+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 9");
		else
			pgf_draw_text( 25, 412+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 9");
		
		if (MenuSelection == 10)
			pgf_draw_text( 25, 452+y2, RGBA8(255, 255, 255, eC), 1, "Net profile 10");
		else
			pgf_draw_text( 25, 452+y2, NETPROFILECHECK_MENU_COLOR, 1, "Net profile 10");
		
		
		if (MenuSelection == 1)
			profile01();
		
		else if (MenuSelection == 2)
			profile02();
		
		else if (MenuSelection == 3)
			profile03();
		
		else if (MenuSelection == 4) 
			profile04();
	
		else if (MenuSelection == 5) 
			profile05();
		
		else if (MenuSelection == 6)
			profile06();
		
		else if (MenuSelection == 7)
			profile07();
		
		else if (MenuSelection == 8)
			profile08();
		
		else if (MenuSelection == 9) 
			profile09();
	
		else if (MenuSelection == 10) 
			profile10();
		
}

void initNetProfileCheckMenu() {

	memset(&NetProfileCheck_menu, 0, sizeof(NetProfileCheckMenu));
	NetProfileCheck_menu.status = NetProfileCheck_MENU_CLOSED;
	n_NetProfileCheck_entries = 1;
}

void openNetProfileCheckMenu() {
	NetProfileCheck_menu.status = NetProfileCheck_MENU_OPENING;
}

void closeNetProfileCheckMenu() {
	NetProfileCheck_menu.status = NetProfileCheck_MENU_CLOSING;
}

int getNetProfileCheckMenuStatus() {
	return NetProfileCheck_menu.status;
}

void drawNetProfileCheckMenu() {
  
	if (NetProfileCheck_menu.status == NetProfileCheck_MENU_CLOSED)
		return;

	// Closing settings menu
	if (NetProfileCheck_menu.status == NetProfileCheck_MENU_CLOSING) {
		if (NetProfileCheck_menu.cur_pos > 0.0f) {
			NetProfileCheck_menu.cur_pos -= easeOut(0.0f, NetProfileCheck_menu.cur_pos, 0.25f, 0.01f);
		} else {
			NetProfileCheck_menu.status = NetProfileCheck_MENU_CLOSED;
		}
	}

	// Opening settings menu
	if (NetProfileCheck_menu.status == NetProfileCheck_MENU_OPENING) {
		if (NetProfileCheck_menu.cur_pos < SCREEN_HEIGHT) {
			NetProfileCheck_menu.cur_pos += easeOut(NetProfileCheck_menu.cur_pos, SCREEN_HEIGHT, 0.25f, 0.01f);
		} else {
			NetProfileCheck_menu.status = NetProfileCheck_MENU_OPENED;
		}
	}

	// Draw settings menu
	vita2d_draw_texture(netprofilecheck_image, 0.0f, SCREEN_HEIGHT - NetProfileCheck_menu.cur_pos);
	
	if (NetProfileCheck_menu.cur_pos > 0.0f) {
		npc_mainMenu();
	}
}

static int agreement = NetProfileCheck_AGREEMENT_NONE;

void NetProfileCheckAgree() {
	agreement = NetProfileCheck_AGREEMENT_AGREE;
}

void NetProfileCheckDisagree() {
	agreement = NetProfileCheck_AGREEMENT_DISAGREE;
}

void NetProfileCheckMenuCtrl() {

	// Agreement
	if (agreement != NetProfileCheck_AGREEMENT_NONE) {
		agreement = NetProfileCheck_AGREEMENT_NONE;
	}

	if(pressed_buttons & SCE_CTRL_DOWN){
			MenuSelection++; //Moves the selector down
	}
    else if(pressed_buttons & SCE_CTRL_UP){
			MenuSelection--; //Moves the selector up
	}else if (pressed_buttons & SCE_CTRL_CANCEL) {
		closeNetProfileCheckMenu();
	}
        
        if (MenuSelection > numMenuItems) 
			MenuSelection = 1; //Sets the selection to the first
        if (MenuSelection < 1) 
			MenuSelection = numMenuItems; //Sets the selection back to last
		
}
