#include "../main.h"
#include "../config.h"
#include "../init.h"
#include "../theme.h"
#include "../language.h"
#include "../message_dialog.h"
#include "../ime_dialog.h"
#include "../utils.h"
#include "vitaident.h"

//extern unsigned char _binary_resources_default_VITAident_png_start;
char patch[MAX_PATH_LENGTH];
float width;

static int n_Vitaident_entries = 0;
static VitaidentMenu Vitaident_menu;

static int MenuSelection = 1; // Pretty obvious
static int selector_x = 17; //The x position of the first selection
static int selector_y = 26; //The y position of the first selection
static int numMenuItems = 6; //Amount of items in the menu
//static int selector_image_x = 0; //Determines the starting x position of the selection
//static int selector_image_y = 0; //Determines the starting y position of the selection
static char version[16] = "";

void initVitaidentMenu() {

	memset(&Vitaident_menu, 0, sizeof(VitaidentMenu));
	Vitaident_menu.status = VITAIDENT_MENU_CLOSED;
	n_Vitaident_entries = 1;
	
	strcpy(version, getFwVersion(false));

}

void openVitaidentMenu() {
	Vitaident_menu.status = VITAIDENT_MENU_OPENING;
}

void closeVitaidentMenu() {
	Vitaident_menu.status = VITAIDENT_MENU_CLOSING;
}

int getVitaidentMenuStatus() {
	return Vitaident_menu.status;
}

void nameWidth(char *name){
	width = vita2d_pgf_text_width(font, 1, name);
}

void kernelMenu()
{		
	float slide_x = Vitaident_menu.cur_pos - SCREEN_WIDTH;
	
	pgf_draw_text(545+slide_x, 105, VITAIDENT_TITLE_KERNEL_COLOR, 1, "Kernel Menu");
	//float width = vita2d_pgf_text_width(font, 1, "System version: ");
		
	//pgf_draw_text(364, 265, RGBA8(51, 51, 51, 255), 1, "Firmware version: %.4s\n", getFwVersion(false));
	
	/*snprintf(patch, MAX_PATH_LENGTH, "%.4s\n", version);
	pgf_draw_text(364, 265, VITAIDENT_KERNEL_NAME_COLOR, 1, "Firmware version: ");
	nameWidth("Firmware version: ");
	pgf_draw_text(364 + width + 10, 265, VITAIDENT_KERNEL_ITEM_COLOR, 1, patch);*/
	
	//snprintf(patch, MAX_PATH_LENGTH, "%.4s\n", getFwVersion(true));
	pgf_draw_text(320+slide_x, 240, VITAIDENT_KERNEL_NAME_COLOR, 1, "System version:");
	nameWidth("System version:");
	pgf_draw_text(320 + width + 5+slide_x, 240, VITAIDENT_KERNEL_ITEM_COLOR, 1, getFwVersion(true));
	
	snprintf(patch, MAX_PATH_LENGTH, "%s  %s  (0x%08X)\n", getDeviceModel(), vshSysconHasWWAN()? "3G" : "WiFi", getModel());
	pgf_draw_text(320+slide_x, 280, VITAIDENT_KERNEL_NAME_COLOR, 1, "Model version:");
	nameWidth("Model version:");
	pgf_draw_text(320 + width + 5+slide_x, 280, VITAIDENT_KERNEL_ITEM_COLOR, 1, patch);
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", getUnit());
	pgf_draw_text(320+slide_x, 320, VITAIDENT_KERNEL_NAME_COLOR, 1, "PS Vita unit:");
	nameWidth("PS Vita unit:");
	pgf_draw_text(320 + width + 5+slide_x, 320, VITAIDENT_KERNEL_ITEM_COLOR, 1, getUnit());
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", getBoard());
	pgf_draw_text(320+slide_x, 360, VITAIDENT_KERNEL_NAME_COLOR, 1, "Motherboard:");
	nameWidth("Motherboard:");
	pgf_draw_text(320 + width + 5+slide_x, 360, VITAIDENT_KERNEL_ITEM_COLOR, 1, getBoard());
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", getCID());
	pgf_draw_text(320+slide_x, 400, VITAIDENT_KERNEL_NAME_COLOR, 1, "PS Vita CID:");
	nameWidth("PS Vita CID:");
	pgf_draw_text(320 + width + 5+slide_x, 400, VITAIDENT_KERNEL_ITEM_COLOR, 1, getCID()); //Thanks Major_Tom
	
	snprintf(patch, MAX_PATH_LENGTH, "%02X\n", getPSID());
	pgf_draw_text(320+slide_x, 440, VITAIDENT_KERNEL_NAME_COLOR, 1, "PSID:");
	nameWidth("PSID:");
	pgf_draw_text(320 + width + 5+slide_x, 440, VITAIDENT_KERNEL_ITEM_COLOR, 1, patch); //Thanks SMOKE
}

void systemMenu()
{
	float slide_x = Vitaident_menu.cur_pos - SCREEN_WIDTH;
	
	pgf_draw_text(545+slide_x, 105, VITAIDENT_TITLE_SYSTEM_COLOR, 1, "System Menu");
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", getLang());
	pgf_draw_text(320+slide_x, 200, VITAIDENT_SYSTEM_NAME_COLOR, 1, "Language:");
	nameWidth("Language:");
	pgf_draw_text(320 + width + 5+slide_x, 200, VITAIDENT_SYSTEM_ITEM_COLOR, 1, getLang());
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", getMacAddress());
	pgf_draw_text(320+slide_x, 240, VITAIDENT_SYSTEM_NAME_COLOR, 1, "MAC address:");
	nameWidth("MAC address:");
	pgf_draw_text(320 + width + 5+slide_x, 240, VITAIDENT_SYSTEM_ITEM_COLOR, 1, getMacAddress());
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", getIP());
	pgf_draw_text(320+slide_x, 280, VITAIDENT_SYSTEM_NAME_COLOR, 1, "IP address:");
	nameWidth("IP address:");
	pgf_draw_text(320 + width + 5+slide_x, 280, VITAIDENT_SYSTEM_ITEM_COLOR, 1, getIP());
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", getUser());
	pgf_draw_text(320+slide_x, 320, VITAIDENT_SYSTEM_NAME_COLOR, 1, "Username:");
	nameWidth("Username:");
	pgf_draw_text(320 + width + 5+slide_x, 320, VITAIDENT_SYSTEM_ITEM_COLOR, 1, getUser());
	
	snprintf(patch, MAX_PATH_LENGTH, "%d MHz\n", getClockFrequency(ClockFrequencyType_Cpu));
	pgf_draw_text(320+slide_x, 360, VITAIDENT_SYSTEM_NAME_COLOR, 1, "ARM clock frequency:");
	nameWidth("ARM clock frequency:");
	pgf_draw_text(320 + width + 5+slide_x, 360, VITAIDENT_SYSTEM_ITEM_COLOR, 1, patch);
	
	snprintf(patch, MAX_PATH_LENGTH, "%d MHz\n", getClockFrequency(ClockFrequencyType_Bus));
	pgf_draw_text(320+slide_x, 400, VITAIDENT_SYSTEM_NAME_COLOR, 1, "BUS clock frequency:");
	nameWidth("BUS clock frequency:");
	pgf_draw_text(320 + width + 5+slide_x, 400, VITAIDENT_SYSTEM_ITEM_COLOR, 1, patch);
	
	snprintf(patch, MAX_PATH_LENGTH, "%d MHz\n\n", getClockFrequency(ClockFrequencyType_GpuXbar));
	pgf_draw_text(320+slide_x, 440, VITAIDENT_SYSTEM_NAME_COLOR, 1, "GPU Xbar clock frequency:");
	nameWidth("GPU Xbar clock frequency:");
	pgf_draw_text(320 + width + 5+slide_x, 440, VITAIDENT_SYSTEM_ITEM_COLOR, 1, patch);
}

void batteryMenu()
{
	float slide_x = Vitaident_menu.cur_pos - SCREEN_WIDTH;
	
	pgf_draw_text(545+slide_x, 105, VITAIDENT_TITLE_BATTERY_COLOR, 1, "Battery Menu");
	
	//snprintf(patch, MAX_PATH_LENGTH, "%s (%s)\n", getBatteryPercentage(), getBatteryStatus());
	//pgf_draw_text(364, 305, VITAIDENT_BATTERY_NAME_COLOR, 1, "Battery percentage: ");
	//pgf_draw_text(364, 265, VITAIDENT_BATTERY_ITEM_COLOR, 1, patch);
	//snprintf(patch, MAX_PATH_LENGTH, "%s (remaining: %s)\n", getBatteryCapacity(), getBatteryRemainCapacity());
	pgf_draw_text(320+slide_x, 200, VITAIDENT_BATTERY_NAME_COLOR, 1, "Battery capacity:");
	nameWidth("Battery capacity:");
	pgf_draw_text(320 + width + 5+slide_x, 200, VITAIDENT_BATTERY_ITEM_COLOR, 1, getBatteryCapacity());
	pgf_draw_text(320 + width + 120+slide_x, 200, VITAIDENT_BATTERY_NAME_COLOR, 1, "(remaining:");
	//nameWidth("(remaining:");
	pgf_draw_text(320 + width + 230+slide_x, 200, VITAIDENT_BATTERY_ITEM_COLOR, 1, getBatteryRemainCapacity());
	pgf_draw_text(320 + width + 338+slide_x, 200, VITAIDENT_BATTERY_NAME_COLOR, 1, ")");
	
	//pgf_draw_text(364, 305, VITAIDENT_BATTERY_ITEM_COLOR, 1, patch);
	int batteryLifeTime = scePowerGetBatteryLifeTime();
	snprintf(patch, MAX_PATH_LENGTH, "%02dh %02dm", batteryLifeTime/60, batteryLifeTime-(batteryLifeTime/60*60));
	pgf_draw_text(320+slide_x, 240, VITAIDENT_BATTERY_NAME_COLOR, 1, "Battery life time:");
	nameWidth("Battery life time:");
	pgf_draw_text(320 + width + 5+slide_x, 240, VITAIDENT_BATTERY_ITEM_COLOR, 1, patch);
	pgf_draw_text(320 + width + 105+slide_x, 240, VITAIDENT_BATTERY_NAME_COLOR, 1, "(SOH:");
	//nameWidth("(SOH:");
	pgf_draw_text(320 + width + 165+slide_x, 240, VITAIDENT_BATTERY_ITEM_COLOR, 1, getBatterySOH());
	pgf_draw_text(320 + width + 213+slide_x, 240, VITAIDENT_BATTERY_NAME_COLOR, 1, ")");
	
	snprintf(patch, MAX_PATH_LENGTH, "%s C", getBatteryTemp(0));
	pgf_draw_text(320+slide_x, 280, VITAIDENT_BATTERY_NAME_COLOR, 1, "Battery temperature:");
	nameWidth("Battery temperature:");
	pgf_draw_text(320 + width + 5+slide_x, 280, VITAIDENT_BATTERY_ITEM_COLOR, 1, patch);
	pgf_draw_text(320 + width + 80+slide_x, 280, VITAIDENT_BATTERY_NAME_COLOR, 1, "(");
	snprintf(patch, MAX_PATH_LENGTH, "%s F", getBatteryTemp(1));
	pgf_draw_text(320 + width + 90+slide_x, 280, VITAIDENT_BATTERY_ITEM_COLOR, 1, patch);
	pgf_draw_text(320 + width + 157+slide_x, 280, VITAIDENT_BATTERY_NAME_COLOR, 1, ")");
	
	snprintf(patch, MAX_PATH_LENGTH, "%s V", getBatteryVoltage());
	pgf_draw_text(320+slide_x, 320, VITAIDENT_BATTERY_NAME_COLOR, 1, "Battery voltage:");
	nameWidth("Battery voltage:");
	pgf_draw_text(320 + width + 5+slide_x, 320, VITAIDENT_BATTERY_ITEM_COLOR, 1, patch);
	pgf_draw_text(320 + width + 65+slide_x, 320, VITAIDENT_BATTERY_NAME_COLOR, 1, "(cycle count:");
	//nameWidth("(cycle count:");
	pgf_draw_text(320 + width + 193+slide_x, 320, VITAIDENT_BATTERY_ITEM_COLOR, 1, getBatteryCycleCount());
	pgf_draw_text(320 + width + 224+slide_x, 320, VITAIDENT_BATTERY_NAME_COLOR, 1, ")");
	
	snprintf(patch, MAX_PATH_LENGTH, "%s", getUdcdCableState());
	pgf_draw_text(320+slide_x, 360, VITAIDENT_BATTERY_NAME_COLOR, 1, "Udcd state:");
	nameWidth("Udcd state:");
	pgf_draw_text(320 + width + 5+slide_x, 360, VITAIDENT_BATTERY_ITEM_COLOR, 1, patch);
	pgf_draw_text(320 + width + 205+slide_x, 360, VITAIDENT_BATTERY_NAME_COLOR, 1, "(");
	pgf_draw_text(320 + width + 215+slide_x, 360, VITAIDENT_BATTERY_ITEM_COLOR, 1, getUsbChargingState());
	pgf_draw_text(320 + width + 435+slide_x, 360, VITAIDENT_BATTERY_NAME_COLOR, 1, ")");
	
}

void miscMenu()
{		
	float slide_x = Vitaident_menu.cur_pos - SCREEN_WIDTH;
	
	pgf_draw_text(545+slide_x, 105, VITAIDENT_TITLE_MISC_COLOR, 1, "Misc Menu");
	
	//snprintf(patch, MAX_PATH_LENGTH, "Enter button: %s\n", getEnterButton()? "Cross (X)" : "Circle (O)");
	pgf_draw_text(320+slide_x, 200, VITAIDENT_MISC_NAME_COLOR, 1, "Enter button:");
	nameWidth("Enter button:");
	pgf_draw_text(320 + width + 5+slide_x, 200, VITAIDENT_MISC_ITEM_COLOR, 1, getEnterButton()? "Cross (X)" : "Circle (O)");
	
	snprintf(patch, MAX_PATH_LENGTH, "%d%%", getBrightness());
	pgf_draw_text(320+slide_x, 240, VITAIDENT_MISC_NAME_COLOR, 1, "Brightness:");
	nameWidth("Brightness:");
	pgf_draw_text(320 + width + 5+slide_x, 240, VITAIDENT_MISC_ITEM_COLOR, 1, patch);
	
	snprintf(patch, MAX_PATH_LENGTH, "%d%%", getVolume());
	pgf_draw_text(320+slide_x, 280, VITAIDENT_MISC_NAME_COLOR, 1, "Volume:");
	nameWidth("Volume:");
	pgf_draw_text(320 + width + 5+slide_x, 280, VITAIDENT_MISC_ITEM_COLOR, 1, patch);

	char free_size_string[16], max_size_string[16];
	SceOff freeSize = getPartitionInfo(0, "ur0:");
	SceOff maxSize = getPartitionInfo(1, "ur0:");
	
	getSizeString(free_size_string, freeSize);
	getSizeString(max_size_string, maxSize);

	//snprintf(patch, MAX_PATH_LENGTH, "%s\n", max_size_string);
	pgf_draw_text(320+slide_x, 320, VITAIDENT_MISC_NAME_COLOR, 1, "Internal storage:");
	nameWidth("Internal storage:");
	pgf_draw_text(320 + width + 5+slide_x, 320, VITAIDENT_MISC_ITEM_COLOR, 1, max_size_string);
	
	//snprintf(patch, MAX_PATH_LENGTH, "Internal storage free: %s\n", free_size_string);
	pgf_draw_text(320+slide_x, 360, VITAIDENT_MISC_NAME_COLOR, 1, "Internal storage free:");
	nameWidth("Internal storage free:");
	pgf_draw_text(320 + width + 5+slide_x, 360, VITAIDENT_MISC_ITEM_COLOR, 1, free_size_string);
	
	if (vshRemovableMemoryGetCardInsertState() == 1)
	{
		//snprintf(patch, MAX_PATH_LENGTH, "Memory card storage: %s\n", getStorageInfo(0));
		pgf_draw_text(320+slide_x, 400, VITAIDENT_MISC_NAME_COLOR, 1, "Memory card storage:");
		nameWidth("Memory card storage:");
		pgf_draw_text(320 + width + 5+slide_x, 400, VITAIDENT_MISC_ITEM_COLOR, 1, getStorageInfo(0));
		
		//snprintf(patch, MAX_PATH_LENGTH, "Memory card storage free: %s\n", getStorageInfo(1));
		pgf_draw_text(320+slide_x, 440, VITAIDENT_MISC_NAME_COLOR, 1, "Memory card storage free:");
		nameWidth("Memory card storage free:");
		pgf_draw_text(320 + width + 5+slide_x, 440, VITAIDENT_MISC_ITEM_COLOR, 1, getStorageInfo(1));	
	}	
}

void configMenu()
{		
	float slide_x = Vitaident_menu.cur_pos - SCREEN_WIDTH;
	
	pgf_draw_text(545+slide_x, 105, VITAIDENT_TITLE_CONFIG_COLOR, 1, "Config Menu");
	
	//snprintf(patch, MAX_PATH_LENGTH, "Airplane mode: %s\n", regMgrGetInt("/CONFIG/SYSTEM/", "flight_mode")? "enabled" : "disabled");
	pgf_draw_text(320+slide_x, 200, VITAIDENT_CONFIG_NAME_COLOR, 1, "Airplane mode:");
	nameWidth("Airplane mode:");
	pgf_draw_text(320 + width + 5+slide_x, 200, VITAIDENT_CONFIG_ITEM_COLOR, 1, regMgrGetInt("/CONFIG/SYSTEM/", "flight_mode")? "enabled" : "disabled");
	
	//snprintf(patch, MAX_PATH_LENGTH, "Bluetooth: %s\n", regMgrGetInt("/CONFIG/BT/", "bt_enable")? "enabled" : "disabled");
	pgf_draw_text(320+slide_x, 240, VITAIDENT_CONFIG_NAME_COLOR, 1, "Bluetooth:");
	nameWidth("Bluetooth:");
	pgf_draw_text(320 + width + 5+slide_x, 240, VITAIDENT_CONFIG_ITEM_COLOR, 1, regMgrGetInt("/CONFIG/BT/", "bt_enable")? "enabled" : "disabled");
	
	//snprintf(patch, MAX_PATH_LENGTH, "WiFi power save: %s\n", regMgrGetInt("/CONFIG/NET/", "wifi_power_save")? "enabled" : "disabled");
	pgf_draw_text(320+slide_x, 280, VITAIDENT_CONFIG_NAME_COLOR, 1, "WiFi power save:");
	nameWidth("WiFi power save:");
	pgf_draw_text(320 + width + 5+slide_x, 280, VITAIDENT_CONFIG_ITEM_COLOR, 1, regMgrGetInt("/CONFIG/NET/", "wifi_power_save")? "enabled" : "disabled");
	
	//snprintf(patch, MAX_PATH_LENGTH, "Screen lock passcode: %s\n", regMgrGetStr("/CONFIG/SECURITY/SCREEN_LOCK/", "passcode"));
	pgf_draw_text(320+slide_x, 320, VITAIDENT_CONFIG_NAME_COLOR, 1, "Screen lock passcode:");
	nameWidth("Screen lock passcode:");
	pgf_draw_text(320 + width + 5+slide_x, 320, VITAIDENT_CONFIG_ITEM_COLOR, 1, regMgrGetStr("/CONFIG/SECURITY/SCREEN_LOCK/", "passcode"));
}

void psnMenu()
{		
	float slide_x = Vitaident_menu.cur_pos - SCREEN_WIDTH;
	
	pgf_draw_text(545+slide_x, 105, VITAIDENT_TITLE_PSN_COLOR, 1, "PSN Menu");
	
	//snprintf(patch, MAX_PATH_LENGTH, "NP: %s\n", regMgrGetInt("/CONFIG/NP/", "enable_np")? "enabled" : "disabled");
	pgf_draw_text(320+slide_x, 200, VITAIDENT_PSN_NAME_COLOR, 1, "NP:");
	nameWidth("NP:");
	pgf_draw_text(320 + width + 5+slide_x, 200, VITAIDENT_PSN_ITEM_COLOR, 1, regMgrGetInt("/CONFIG/NP/", "enable_np")? "enabled" : "disabled");
	
	//pgf_draw_text(364, 305, RGBA8(51, 51, 51, 255), 1, "Account ID: %s\n",  regMgrGetBin("/CONFIG/NP/", "account_id"));
	//snprintf(patch, MAX_PATH_LENGTH, "Login ID: %s\n", regMgrGetStr("/CONFIG/NP/", "login_id"));
	pgf_draw_text(320+slide_x, 240, VITAIDENT_PSN_NAME_COLOR, 1, "Login ID:");
	nameWidth("Login ID:");
	pgf_draw_text(320 + width + 5+slide_x, 240, VITAIDENT_PSN_ITEM_COLOR, 1, regMgrGetStr("/CONFIG/NP/", "login_id"));
	
	//snprintf(patch, MAX_PATH_LENGTH, "Password: %s\n", regMgrGetStr("/CONFIG/NP/", "password"));
	pgf_draw_text(320+slide_x, 280, VITAIDENT_PSN_NAME_COLOR, 1, "Password:");
	nameWidth("Password:");
	pgf_draw_text(320 + width + 5+slide_x, 280, VITAIDENT_PSN_ITEM_COLOR, 1, regMgrGetStr("/CONFIG/NP/", "password"));
}

void mainMenu()
{
	/*int MenuSelection = 1; // Pretty obvious
	int selector_x = 17; //The x position of the first selection
	int selector_y = 26; //The y position of the first selection
	int numMenuItems = 6; //Amount of items in the menu
	int selector_image_x = 0; //Determines the starting x position of the selection
	int selector_image_y = 0; //Determines the starting y position of the selection
	
	static char version[16] = "";
	strcpy(version, getFwVersion(false));*/ //For saftey purposes, I don't want this in a while loop.
	//if (vitaident_image)
		//vita2d_texture_set_filters(vitaident_image, SCE_GXM_TEXTURE_FILTER_LINEAR, SCE_GXM_TEXTURE_FILTER_LINEAR);
	
	//while (1) 
	//{	
		//selector_image_x = selector_x + (selector_xDistance * MenuSelection); //Determines where the selection image is drawn for each selection
        //selector_image_y = selector_y + (selector_yDistance * MenuSelection); //Determines where the selection image is drawn for each selection
		
		//readPad();
		
		/*if(hold_buttons & SCE_CTRL_DOWN)
			MenuSelection++; //Moves the selector down
        else if(hold_buttons & SCE_CTRL_UP)
			MenuSelection--; //Moves the selector up
		else if(pressed_buttons & SCE_CTRL_CANCEL)
			break;
        
        if (MenuSelection > numMenuItems) 
			MenuSelection = 1; //Sets the selection to the first
        if (MenuSelection < 1) 
			MenuSelection = numMenuItems; //Sets the selection back to last*/
		
		
		
		//startDrawing(vitaident_image);
		//vita2d_clear_screen();
		
		//vita2d_draw_texture(VITAident, 0, 0);
		
		//vita2d_draw_rectangle(selector_image_x, selector_image_y, 250, 40, RGBA8(242, 119, 62, 255));
		
		uint32_t eC = epileptik();
		
		//pgf_draw_text(15, 30, RGBA8(255, 255, 255, 255), 1, "VITAident 0.7.2");
		
		float slide_x = Vitaident_menu.cur_pos - SCREEN_WIDTH;
				
		if (MenuSelection == 1)
			pgf_draw_text(25+slide_x, 220, RGBA8(255, 255, 255, eC), 1.1f, "Kernel Information");
		else 
			pgf_draw_text(25+slide_x, 220, VITAIDENT_MENU_KERNEL_COLOR, 1.1f, "Kernel Information");
		
		if (MenuSelection == 2)
			pgf_draw_text(25+slide_x, 260, RGBA8(255, 255, 255, eC), 1.1f, "Systeme Information");
		else
			pgf_draw_text(25+slide_x, 260, VITAIDENT_MENU_SYSTEM_COLOR, 1.1f, "Systeme Information");
		
		if (MenuSelection == 3)
			pgf_draw_text(25+slide_x, 300, RGBA8(255, 255, 255, eC), 1.1f, "Battery Information");
		else
			pgf_draw_text(25+slide_x, 300, VITAIDENT_MENU_BATTERY_COLOR, 1.1f, "Battery Information");
		
		if (MenuSelection == 4)
			pgf_draw_text(25+slide_x, 340, RGBA8(255, 255, 255, eC), 1.1f, "Miscelleanous");
		else
			pgf_draw_text(25+slide_x, 340, VITAIDENT_MENU_MISC_COLOR, 1.1f, "Miscelleanous");
		
		if (MenuSelection == 5)
			pgf_draw_text(25+slide_x, 380, RGBA8(255, 255, 255, eC), 1.1f, "Config");
		else
			pgf_draw_text(25+slide_x, 380, VITAIDENT_MENU_CONFIG_COLOR, 1.1f, "Config");
		
		if (MenuSelection == 6)
			pgf_draw_text(25+slide_x, 420, RGBA8(255, 255, 255, eC), 1.1f, "PSN");
		else
			pgf_draw_text(25+slide_x, 420, VITAIDENT_MENU_PSN_COLOR, 1.1f, "PSN");
		
		/*if (MenuSelection == 7)
			pgf_draw_text(25, 332, RGBA8(255, 255, 255, 255), 1.1f, "Exit");
		else
			pgf_draw_text(25, 332, RGBA8(78, 74, 67, 255), 1.1f, "Exit");*/
		
		
		if (MenuSelection == 1)
		{
			kernelMenu();
			snprintf(patch, MAX_PATH_LENGTH, "%.4s", version);
			pgf_draw_text(320+slide_x, 200, VITAIDENT_KERNEL_NAME_COLOR, 1, "Firmware version:");
			nameWidth("Firmware version:");
			pgf_draw_text(320 + width + 5+slide_x, 200, VITAIDENT_KERNEL_ITEM_COLOR, 1, patch);
		}
		
		else if (MenuSelection == 2)
			systemMenu();
		
		else if (MenuSelection == 3)
			batteryMenu();
		
		else if (MenuSelection == 4) 
			miscMenu();
		
		else if (MenuSelection == 5) 
			configMenu();
		
		else if (MenuSelection == 6) 
			psnMenu();
		
		
		/*else if (MenuSelection == 7)
		{
			if (getEnterButton() == 0)
			{
				if (pressed_buttons & SCE_CTRL_CANCEL)
					break;
			}
			else
			{
				if (pressed_buttons & SCE_CTRL_ENTER)
					break;
			}
		}*/
		
		//endDrawing();
	//}	
	//vita2d_wait_rendering_done();
	
	//return 0;
}

/*int Vitaidentmain() 
{
	//initAppUtil();
	//initNet();
	//vita2d_init();
	
	//vita2d_set_clear_color(RGBA8(0, 0, 0, 255));
	
	//VITAident = loadPngWithFilter(&_binary_resources_default_VITAident_png_start);
	
	//font = vita2d_load_default_pvf();
	
	while(1)
        mainMenu();
	
	//vita2d_fini();
	//vita2d_free_texture(VITAident);
	//vita2d_free_pvf(font);
	//termNet();
	//termAppUtil();
	//sceKernelExitProcess(0);
	
	return 0;
}*/


/*int controls()
{
	memset(&pad, 0, sizeof(SceCtrlData));
	sceCtrlPeekBufferPositive(0, &pad, 1);

	pressed = pad.buttons & ~old_pad.buttons;
	
	old_pad = pad;
	return 0;
}*/

void drawVitaidentMenu() {
  
	if (Vitaident_menu.status == VITAIDENT_MENU_CLOSED)
		return;

	// Closing settings menu
	if (Vitaident_menu.status == VITAIDENT_MENU_CLOSING) {
		if (Vitaident_menu.cur_pos > 0.0f) {
			Vitaident_menu.cur_pos -= easeOut(0.0f, Vitaident_menu.cur_pos, 0.25f, 0.01f);
		} else {
			Vitaident_menu.status = VITAIDENT_MENU_CLOSED;
		}
	}

	// Opening settings menu
	if (Vitaident_menu.status == VITAIDENT_MENU_OPENING) {
		if (Vitaident_menu.cur_pos < SCREEN_WIDTH) {
			Vitaident_menu.cur_pos += easeOut(Vitaident_menu.cur_pos, SCREEN_WIDTH, 0.25f, 0.01f);
		} else {
			Vitaident_menu.status = VITAIDENT_MENU_OPENED;
		}
	}

	// Draw settings menu
	vita2d_draw_texture(vitaident_image, Vitaident_menu.cur_pos - SCREEN_WIDTH, 0.0f);
	
	if (Vitaident_menu.cur_pos > 0.0f) {
		mainMenu();
	}
}

static int agreement = VITAIDENT_AGREEMENT_NONE;

void VitaidentAgree() {
	agreement = VITAIDENT_AGREEMENT_AGREE;
}

void VitaidentDisagree() {
	agreement = VITAIDENT_AGREEMENT_DISAGREE;
}

void VitaidentMenuCtrl() {

	// Agreement
	if (agreement != VITAIDENT_AGREEMENT_NONE) {
		agreement = VITAIDENT_AGREEMENT_NONE;
	}

		if(pressed_buttons & SCE_CTRL_DOWN){
			MenuSelection++; //Moves the selector down
		}
        else if(pressed_buttons & SCE_CTRL_UP){
			MenuSelection--; //Moves the selector up
		}
		else if(pressed_buttons & SCE_CTRL_CANCEL){
			closeVitaidentMenu();
		}
        
        if (MenuSelection > numMenuItems) 
			MenuSelection = 1; //Sets the selection to the first
        if (MenuSelection < 1) 
			MenuSelection = numMenuItems; //Sets the selection back to last
	
	// Close
	/*if (pressed_buttons & SCE_CTRL_CANCEL) {
		closeVitaidentMenu();
	}*/
}
